> ## Documentation Index
> Fetch the complete documentation index at: https://docs.authsignal.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Initiate Challenge

> Initiate a challenge for an action. Call this before Generate Authentication Options to customize the action code for passkey sign-in.



## OpenAPI

````yaml client-api POST /challenge
openapi: 3.0.0
info:
  description: Authsignal's Client API.
  version: 1.0.0
  title: Client API
  termsOfService: https://www.authsignal.com/legal/terms-of-service
  contact:
    email: hello@authsignal.com
servers:
  - url: https://api.authsignal.com/v1/client
  - url: https://au.api.authsignal.com/v1/client
  - url: https://eu.api.authsignal.com/v1/client
  - url: https://ca.api.authsignal.com/v1/client
security:
  - bearerAuth: []
tags:
  - name: User authenticators
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: SMS
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: WhatsApp
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: Email Magic Link
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: Email OTP
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: Authenticator App
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: Passkeys
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
externalDocs:
  description: Find out more about Authsignal
  url: https://docs.authsignal.com
paths:
  /challenge:
    post:
      tags:
        - Passkeys
      summary: Initiate Challenge
      description: >-
        Initiate a challenge for an action. Call this before Generate
        Authentication Options to customize the action code for passkey sign-in.
      operationId: initiateChallenge
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                action:
                  type: string
                  description: >-
                    The action code which will be associated with the passkey
                    sign-in.
              required:
                - action
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  challengeId:
                    type: string
                    description: >-
                      The ID of the challenge. This value can be passed to
                      Generate Authentication Options.
                required:
                  - challengeId
        '400':
          $ref: '#/components/responses/InvalidRequest'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '404':
          $ref: '#/components/responses/NotFound'
components:
  responses:
    InvalidRequest:
      description: Invalid Request
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
    Unauthorized:
      description: Unauthorized
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorWithCode'
    NotFound:
      description: Not Found
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
  schemas:
    Error:
      type: object
      properties:
        error:
          type: string
        errorDescription:
          type: string
      required:
        - error
    ErrorWithCode:
      type: object
      properties:
        error:
          type: string
        errorDescription:
          type: string
        errorCode:
          type: string
      required:
        - error
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >-
        Use a short-lived token obtained from the Server API's Track Action
        endpoint. The token is valid for 10 minutes and should be passed in the
        Authorization header as 'Bearer {token}'.

````